# net_openhft_ticker_impl_JNIClock.cpp:59:25: error: 'rdtsc' was not declared in this scope
# https://github.com/OpenHFT/Java-Thread-Affinity/issues/32
%ifnarch %{ix86} x86_64
%global debug_package %{nil}
%endif

Name:          openhft-affinity
Version:       3.0.6
Release:       11%{?dist}
Summary:       Java Thread Affinity library
# ASL 2.0 :
# ./affinity/src/main/c/net_openhft_ticker_impl_JNIClock.cpp
# ./affinity/src/main/c/software_chronicle_enterprise_internals_impl_NativeAffinity.cpp
# ./affinity/src/main/c/software_chronicle_enterprise_internals_impl_NativeAffinity_MacOSX.c
# ./affinity/src/main/java/net/openhft/affinity/MicroJitterSampler.java
License:       LGPLv3 and ASL 2.0
URL:           https://github.com/OpenHFT/Java-Thread-Affinity/
Source0:       https://github.com/OpenHFT/Java-Thread-Affinity/archive/affinity-%{version}.tar.gz

BuildRequires: gcc-c++
BuildRequires: maven-local
BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(net.java.dev.jna:jna)
BuildRequires: mvn(net.java.dev.jna:jna-platform)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.felix:org.apache.felix.framework)
BuildRequires: mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires: mvn(org.codehaus.mojo:exec-maven-plugin)
BuildRequires: mvn(org.easymock:easymock)
BuildRequires: mvn(org.jetbrains:annotations)
BuildRequires: mvn(org.osgi:org.osgi.compendium)
BuildRequires: mvn(org.osgi:org.osgi.core)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-simple)

%description
The library will read your /proc/cpuinfo if you have one or
provide one and it will determine your CPU layout.
If you don't have one it will assume every CPU is on one Socket.

The library looks for isolated CPUs determined by looking at the
CPUs you are not running on by default. i.e. if you have 16 CPUs
but 8 of them are not available for general use (as determined
by the affinity of the process on startup) it will start assigning to
those CPUs.

%package javadoc
Summary:       Javadoc for %{name}
BuildArch:     noarch

%description javadoc
This package contains javadoc for %{name}.

%package test
Summary:       OpenHFT Java Thread Affinity Test Library
BuildArch:     noarch

%description test
OpenHFT Java Thread Affinity Test Library.

%prep
%setup -q -n Java-Thread-Affinity-affinity-%{version}

%pom_remove_parent
%pom_xpath_inject pom:project "<groupId>net.openhft</groupId>"

%pom_remove_parent affinity
%pom_xpath_inject pom:project "<groupId>net.openhft</groupId>" affinity

%pom_remove_parent affinity-test
%pom_xpath_inject pom:project "<groupId>net.openhft</groupId>" affinity-test
%pom_xpath_set pom:project/pom:version %{version} affinity-test

#%% pom_disable_module affinity-test
%pom_remove_dep net.openhft:third-party-bom affinity-test
%pom_remove_dep org.ops4j.pax.exam: affinity-test
%pom_remove_dep org.ops4j.pax.url: affinity-test
rm -r affinity-test/src/test
%pom_change_dep com.sun.java:tools com.sun:tools affinity-test

%pom_remove_plugin :depends-maven-plugin affinity
%pom_remove_plugin :maven-scm-publish-plugin affinity

%pom_remove_plugin :depends-maven-plugin affinity-test

%pom_remove_dep net.openhft:third-party-bom affinity
%pom_change_dep com.intellij: org.jetbrains: affinity

%ifnarch %{ix86} x86_64
%pom_remove_plugin :maven-antrun-plugin affinity
%pom_remove_plugin :exec-maven-plugin affinity
%endif

# Set build flags
sed -i "s|-O3 -Wall|${CXXFLAGS:-%optflags}|" affinity/src/main/c/Makefile

# UnsatisfiedLinkError: software.chronicle.enterprise.internals.impl.NativeAffinity.getProcessId0()I
# Fails to load libCEInternals.so
rm affinity/src/test/java/net/openhft/affinity/impl/NativeAffinityImpTest.java \
 affinity/src/test/java/net/openhft/ticker/impl/JNIClockTest.java
# AssertionError PosixJNAAffinityTest#testGettid
rm affinity/src/test/java/net/openhft/affinity/impl/PosixJNAAffinityTest.java

# add symlink
%mvn_file :affinity:jar: %{name}/affinity %{_libdir}/%{name}/affinity

# Useless pom file
%mvn_package :Java-Thread-Affinity __noinstall

%build

%ifnarch %{ix86} x86_64
opts="-f"
%endif
%mvn_build -s $opts -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%ifarch %{ix86} x86_64
install -pm 755 affinity/target/classes/libCEInternals.so %{buildroot}%{_libdir}/%{name}/
%endif

%files -f .mfiles-affinity
%ifarch %{ix86} x86_64
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/libCEInternals.so
%endif
%doc README.md
%license LICENSE

%files javadoc -f .mfiles-javadoc
%license LICENSE

%files test -f .mfiles-affinity-test

%changelog
* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.6-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.6-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.6-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.6-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.6-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Dec 05 2016 Dan Horák <dan[at]danny.cz> 3.0.6-6
- fix non-x86 builds

* Sun Dec 04 2016 gil cattaneo <puntogil@libero.it> 3.0.6-5
- remove test failure

* Mon Sep 12 2016 gil cattaneo <puntogil@libero.it> 3.0.6-4
- exclude power64

* Mon Sep 12 2016 gil cattaneo <puntogil@libero.it> 3.0.6-3
- exclude aarch64
- disable test suite on arm*

* Tue Aug 30 2016 gil cattaneo <puntogil@libero.it> 3.0.6-2
- review fixes

* Sun Jul 24 2016 gil cattaneo <puntogil@libero.it> 3.0.6-1
- initial rpm

